/*****************************************************
Chip type               : ATmega8
AVR Core Clock frequency: 8,000000 MHz
*****************************************************/

#include <mega8.h>

#define s_step 40
#define HIA PORTB.0
#define HIB PORTB.3
#define LOA PORTB.2
#define LOB PORTB.1


unsigned int i; 

flash unsigned char s_table [s_step]=
{
0,20,40,60,79,98,116,134,150,166,181,194,206,217,226,234,241,245,249,250,250,
249,245,241,234,226,217,206,194,181,166,150,134,116,98,79,60,40,20,0
};

void ports_cfg()
{
PORTB=0b00000000;
DDRB=0b11111111;

PORTC=0b01000100;
DDRC=0b00111010;

PORTD=0b00000000;
DDRD=0b01111111;
}
void t1_cfg()
{
TCCR1A=TCCR1B=TIMSK=TCNT1=0;
TCCR1A|=1<<COM1A1|1<<WGM10;
TCCR1B|=1<<WGM12|1<<CS11;   //1MHz
OCR1A=0xF0;

TIMSK|=1<<OCIE1A;
}



interrupt [TIM1_COMPA] void t1_cmpA_isr()
{
static bit p2p;

if ((p2p)&&(!i)){p2p=0; TCCR1A&=~((1<<COM1A1)|(1<<COM1A0));HIA=HIB=0;LOA=LOB=1;}
else if (!i)
    {
    i=s_step;i-=2; p2p=1;
    OCR1A=0x00;TCCR1A=0;TCCR1A|=1<<COM1B1|1<<COM1B0|1<<WGM10;TIMSK=0;TIMSK|=1<<OCIE1B; 
    HIA=0;HIB=1;
    } 
else 
    {
    OCR1AL=s_table[i];i--;
    }
}
interrupt [TIM1_COMPB] void t1_cmpB_isr()
{
static bit p2p;

if ((p2p)&&(!i)){p2p=0; TCCR1A&=~((1<<COM1B1)|(1<<COM1B0));HIA=HIB=0;LOA=LOB=1;}
else if (!i)
    {i=s_step;i-=2; p2p=1;
    OCR1B=0x00;TCCR1A=0;TCCR1A|=1<<COM1A1|1<<COM1A0|1<<WGM10;TIMSK=0;TIMSK|=1<<OCIE1A; 
    HIA=1;HIB=0;
    }
else 
    {
    OCR1BL=s_table[i];i--;}
    }

interrupt [ANA_COMP] void ana_comp_isr(void)
{

}

void main(void)
{
ports_cfg();
t1_cfg();


#asm("sei")
while (1)
      {
      

      }
}
